<template>
  <div class="createPost-container">
    <b-card no-body>
      <b-tabs card>
        <b-tab :title="$t('form.information')" active>
          <b-card-text>
            <b-row class="w-100 mt-5 mb-5 mr-3 ml-3">
              <b-form ref="postForm" :model="postForm" class="w-75">
                <b-form-group :label="$t('form.accountNumber')" label-for="province">
                  <b-form-input id="province" v-model="postForm.accountNumber" type="text" :placeholder="$t('form.accountNumber')" required />
                </b-form-group>

                <b-form-group :label="$t('form.accountId')" label-for="city">
                  <b-form-input id="city" v-model="postForm.accountId" type="text" :placeholder="$t('form.accountId')" required />
                </b-form-group>

                <b-form-group :label="$t('form.shabaNumber')" label-for="address">
                  <b-form-input id="address" v-model="postForm.shabaNumber" type="text" :placeholder="$t('form.shabaNumber')" required />
                </b-form-group>

                <b-form-group :label="$t('user.uploadFile')" label-for="address">
                  <div class="el-form-item el-form-item--medium">
                    <label class="el-form-item__label">
                      {{ $t('user.nationalcodeFile') }}
                    </label>
                    <div class="button-wrap">
                      <label class="new-button" for="upload"> {{ $t('user.uploadFile') }}
                        <input id="upload" type="file" @change="onImageChange">
                      </label>
                    </div>
                  </div>
                </b-form-group>
                <b-button type="submit" variant="primary" @click.prevent.stop="submitForm">{{ $t('form.submit') }}</b-button>
                <b-button type="reset" variant="danger" @click.prevent.stop="onCancel">{{ $t('form.cancel') }}</b-button>
              </b-form>
            </b-row>
          </b-card-text>
        </b-tab>
        <b-tab :title="$t('form.newBani')">
          <b-card-text>
            <b-row class="w-100 mt-5 mb-5 mr-3 ml-3">
              <div v-loading="userCreating" class="form-container w-75">
                <el-form ref="userForm" :model="newBani" label-position="left" class="register-form">
                  <b-row class="w-100 mb-2">
                    <b-col sm="6">
                      <b-row class="w-100">
                        <b-col class="text-right" sm="3">
                          <label>
                            {{ $t('user.name') }}
                          </label>
                        </b-col>
                        <b-col sm="9">
                          <b-form-input
                            id="input-1"
                            v-model="newBani.name"
                            class="ml-2 mr-2"
                            :placeholder="$t('user.name')"
                          >&nbsp;</b-form-input>
                        </b-col>
                      </b-row>
                    </b-col>
                    <b-col sm="6">
                      <b-row class="w-100">
                        <b-col class="text-right" sm="3">
                          <label>
                            {{ $t('user.family') }}
                          </label>
                        </b-col>
                        <b-col sm="9">
                          <b-form-input
                            id="input-1"
                            v-model="newBani.family"
                            class="ml-2 mr-2"
                            :placeholder="$t('user.family')"
                          >&nbsp;</b-form-input>
                        </b-col>
                      </b-row>
                    </b-col>
                  </b-row>

                  <b-row class="w-100 mb-2">
                    <b-col sm="6">
                      <b-row class="w-100">
                        <b-col class="text-right" sm="3">
                          <label>
                            {{ $t('user.nationalcode') }}
                          </label>
                        </b-col>
                        <b-col sm="9">
                          <b-form-input
                            id="input-1"
                            v-model="newBani.nationalcode"
                            class="ml-2 mr-2"
                            :placeholder="$t('user.nationalcode')"
                          >&nbsp;</b-form-input>
                        </b-col>
                      </b-row>
                    </b-col>
                    <b-col sm="6">
                      <b-row class="w-100">
                        <b-col class="text-right" sm="3">
                          <label>
                            {{ $t('user.mobile') }}
                          </label>
                        </b-col>
                        <b-col sm="9">
                          <b-form-input
                            id="input-1"
                            v-model="newBani.mobile"
                            class="ml-2 mr-2"
                            :placeholder="$t('user.mobile')"
                          >&nbsp;</b-form-input>
                        </b-col>
                      </b-row>
                    </b-col>
                  </b-row>

                  <b-row class="w-100 mb-2">
                    <b-col sm="6">
                      <b-row class="w-100">
                        <b-col class="text-right" sm="3">
                          <label>
                            {{ $t('user.password') }}
                          </label>
                        </b-col>
                        <b-col sm="9">
                          <b-form-input
                            id="input-1"
                            v-model="newBani.password"
                            class="ml-2 mr-2"
                            type="password"
                            :placeholder="$t('user.password')"
                          >&nbsp;</b-form-input>
                        </b-col>
                      </b-row>
                    </b-col>
                    <b-col sm="6">
                      <b-row class="w-100">
                        <b-col class="text-right" sm="3">
                          <label>
                            {{ $t('user.confirmPassword') }}
                          </label>
                        </b-col>
                        <b-col sm="9">
                          <b-form-input
                            id="input-1"
                            v-model="newBani.confirmPassword"
                            class="ml-2 mr-2"
                            type="password"
                            :placeholder="$t('user.confirmPassword')"
                          >&nbsp;</b-form-input>
                        </b-col>
                      </b-row>
                    </b-col>
                  </b-row>

                  <b-row class="w-100 mb-2">
                    <b-col sm="6">
                      <b-row class="w-100">
                        <b-col class="text-right" sm="3">
                          <label>
                            {{ $t('form.accountNumber') }}
                          </label>
                        </b-col>
                        <b-col sm="9">
                          <b-form-input
                            id="input-1"
                            v-model="newBani.accountNumber"
                            class="ml-2 mr-2"
                            :placeholder="$t('form.accountNumber')"
                          >&nbsp;</b-form-input>
                        </b-col>
                      </b-row>
                    </b-col>
                    <b-col sm="6">
                      <b-row class="w-100">
                        <b-col class="text-right" sm="3">
                          <label>
                            {{ $t('form.accountId') }}
                          </label>
                        </b-col>
                        <b-col sm="9">
                          <b-form-input
                            id="input-1"
                            v-model="newBani.accountId"
                            class="ml-2 mr-2"
                            :placeholder="$t('form.accountId')"
                          >&nbsp;</b-form-input>
                        </b-col>
                      </b-row>
                    </b-col>
                  </b-row>

                  <b-row class="w-100 mb-2">
                    <b-col sm="6">
                      <b-row class="w-100">
                        <b-col class="text-right" sm="3">
                          <label>
                            {{ $t('form.shabaNumber') }}
                          </label>
                        </b-col>
                        <b-col sm="9">
                          <b-form-input
                            id="input-1"
                            v-model="newBani.shabaNumber"
                            class="ml-2 mr-2"
                            :placeholder="$t('form.shabaNumber')"
                          >&nbsp;</b-form-input>
                        </b-col>
                      </b-row>
                    </b-col>
                  </b-row>
                  <b-row>
                    <b-col sm="6">
                      <b-row class="w-100">
                        <b-form-group :label="$t('user.uploadFile')" label-for="address">
                          <div class="el-form-item el-form-item--medium">
                            <label class="el-form-item__label">
                              {{ $t('user.nationalcodeFile') }}
                            </label>
                            <div class="button-wrap">
                              <label class="new-button" for="upload"> {{ $t('user.uploadFile') }}
                                <input id="upload" type="file" @change="onImageChange">
                              </label>
                            </div>
                          </div>
                        </b-form-group>
                      </b-row>
                    </b-col>
                  </b-row>
                  <b-button type="submit" variant="primary" @click.prevent.stop="submitBaniForm">{{ $t('form.submit') }}</b-button>
                </el-form>
              </div>
            </b-row>
          </b-card-text>
        </b-tab>
      </b-tabs>
    </b-card>
  </div>
</template>

<script>
import Bani from '@/api/task';

const baniApi = new Bani('banis');

export default {
  name: 'BaniDetail',

  components: {},
  props: {
    isEdit: {
      type: Boolean,
      default: false,
    },
  },
  data() {
    return {
      postForm: {
        accountNumber: '',
        accountId: '',
        shabaNumber: '',
      },
      loading: false,
      userCreating: false,
      newBani: {},
      userListOptions: [],
      tempRoute: {},
    };
  },
  computed: {
    contentShortLength() {
      return this.postForm.content_short.length;
    },
    lang() {
      return this.$store.getters.language;
    },
  },
  created() {
    if (this.isEdit) {
      // const id = this.$route.params && this.$route.params.id;
      // this.fetchData(id);
    } else {
      // this.postForm = Object.assign({}, defaultForm);
    }

    // Why need to make a copy of this.$route here?
    // Because if you enter this page and quickly switch tag, may be in the execution of the setTagsViewTitle function, this.$route is no longer pointing to the current page
    this.tempRoute = Object.assign({}, this.$route);
  },
  methods: {
    onImageChange(e) {
      const files = e.target.files || e.dataTransfer.files;
      if (!files.length){
        return;
      }
      this.createImage(files[0]);
    },
    createImage(file) {
      const reader = new FileReader();
      const vm = this;
      reader.onload = (e) => {
        vm.image = e.target.result;
      };
      reader.readAsDataURL(file);
    },
    onSubmit() {
      this.$message('submit!');
    },
    onCancel() {
      this.$message({
        message: 'cancel!',
        type: 'warning',
      });
    },
    submitForm() {
      this.loading = true;
      baniApi
        .registerBani(this.postForm)
        .then(response => {
          this.$message({
            message: 'New Bani ' + this.postForm.title + 'has been created successfully.',
            type: 'success',
            duration: 5 * 1000,
          });
        })
        .catch(error => {
          console.log(error);
        })
        .finally(() => {
          this.userCreating = false;
        });
    },
    submitBaniForm() {
      this.loading = true;
      baniApi
        .registerCreateBani(this.newBani)
        .then(response => {
          this.$message({
            message: 'New Bani ' + this.postForm.title + 'has been created successfully.',
            type: 'success',
            duration: 5 * 1000,
          });
        })
        .catch(error => {
          console.log(error);
        })
        .finally(() => {
          this.userCreating = false;
        });
    },
  },
};
</script>

<style rel="stylesheet/scss" lang="scss" scoped>
@import "~@/styles/mixin.scss";
.createPost-container {
  position: relative;
  .createPost-main-container {
    padding: 0 45px 20px 50px;
    .postInfo-container {
      position: relative;
      @include clearfix;
      margin-bottom: 10px;
      .postInfo-container-item {
        float: left;
      }
    }
  }
  .word-counter {
    width: 40px;
    position: absolute;
    right: -10px;
    top: 0px;
  }
}
</style>
<style>
.createPost-container label.el-form-item__label {
  text-align: left;
}
</style>
